const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const production_operations = sequelize.define(
    'production_operations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

sequence: {
        type: DataTypes.INTEGER,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"ready",


"in_progress",


"blocked",


"done"

        ],

      },

scheduled_start_at: {
        type: DataTypes.DATE,
      
      

      },

scheduled_end_at: {
        type: DataTypes.DATE,
      
      

      },

started_at: {
        type: DataTypes.DATE,
      
      

      },

ended_at: {
        type: DataTypes.DATE,
      
      

      },

planned_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

good_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

scrap_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

work_instructions: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  production_operations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



















    db.production_operations.hasMany(db.quality_inspections, {
      as: 'quality_inspections_operation',
      foreignKey: {
          name: 'operationId',
      },
      constraints: false,
    });











//end loop



    db.production_operations.belongsTo(db.production_orders, {
      as: 'production_order',
      foreignKey: {
        name: 'production_orderId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.machines, {
      as: 'machine',
      foreignKey: {
        name: 'machineId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.users, {
      as: 'assigned_to',
      foreignKey: {
        name: 'assigned_toId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.production_operations.hasMany(db.file, {
      as: 'attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.production_operations.getTableName(),
        belongsToColumn: 'attachments',
      },
    });


    db.production_operations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.production_operations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return production_operations;
};


